import { useQuery } from '@tanstack/react-query'
import { Organizations } from '../../types/services/organization'
import { api } from '../api'

interface OrganizationsQueryParams {
  page?: number
  limit?: number
  search?: string
}

export function useOrganizations(params: OrganizationsQueryParams = {}) {
  const { page = 1, limit = 10, search = '', ...filters } = params

  return useQuery<Organizations>({
    queryKey: ['organizations', { page, limit, search, ...filters }],
    queryFn: async () => {
      const queryParams = new URLSearchParams()

      queryParams.append('page', page.toString())
      queryParams.append('limit', limit.toString())

      if (search) {
        queryParams.append('search', search)
      }

      Object.entries(filters).forEach(([key, value]) => {
        if (value !== undefined && value !== null && value !== '') {
          queryParams.append(key, value.toString())
        }
      })

      const res = await api.get(`/organizations?${queryParams.toString()}`)
      return res.data.data
    }
  })
}
